/*  glibc-check : Some glibc's leak memory in getservbyname - Upgrade or
    don't use ident lookups if this fails.

    Compile with gcc -o glibc-check glibc-check.c

    Copyright (C) 2000 Afghan Hound Software

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA*/

/* glibc-check.c - Checks to see if getservbyname is leaking memory */

#include <config.h>
#include <stdio.h> 
#include <malloc.h>
#include <netdb.h>


main()
{
#if HAVE_MALLINFO
  struct mallinfo *meminfo;
  int i,old = 0;
  printf("AQOTDD glibc testing thingy. ");
  printf("All the following rows should be the same.\n");
  printf("           Memory Usage (bytes)\n");
  printf("Arena   Used Blocks   Free Blocks  Difference\n");
  for(i=0;i<10;i++)
  	{
  		getservbyname("auth","tcp");
      		meminfo = (struct mallinfo *)malloc(sizeof(struct mallinfo));
      		*meminfo = mallinfo();
     		if (old)
     		  {
     		    printf("%5d   %6d         %6d      %6d\n",
     		    			       meminfo->arena,
     		                               meminfo->uordblks,
     		                               meminfo->fordblks,
     		                               old-meminfo->uordblks);
     		  }
     		old = meminfo->uordblks;
      		free(meminfo);
	}
#else /* no mallinfo -> not glibc */
   printf("Your box doesn't seem to have mallinfo, and therefore probably"); 
   printf(" doesn't have glibc - so you are *probably* okay. :)\n");
#endif /* HAVE_MALLINFO */
   exit(0);
}
	                     
